package rekisteri;

/***
 * Kirja luokka.
 * @author jimis
 * @version 29.3.2025
 *
 */
public class Kirja {

    private String teos = "";
    private String kirjailija = "";
    private double hinta;
    private int sivumaara;
    
    /**
     * Tyhjä muodostaja
     */
    public Kirja()
    {        
    }
    
    /**
     * Kirja-olion muodostaja.
     * @param teos teoksien nimi
     * @param kirjailija kirjailijan nimi
     * @param hinta kirjan hinta
     * @param sivumaara sivumäärä
     */
    public Kirja(String teos, String kirjailija, double hinta, int sivumaara)
    {
        this.teos = teos;
        this.kirjailija = kirjailija;
        this.sivumaara = sivumaara;
        this.hinta = hinta;
    }
    
    /**
     * Haetaan Teoksen nimi
     * @return Teoksen nimi
     */
    public String getTeos()
    {
        return teos;
    }
    
    /**
     * Haetaan kirjailijan nimi
     * @return kirjailijan nimi
     */
    public String getKirjailija()
    {
        return kirjailija;
    }
    
    /**
     * Haetaan hinta
     * @return hinta
     */
    public double getHinta()
    {
        return hinta;
    }
    
    /**
     * Haetaan sivumaara
     * @return sivumaara
     */
    public int getSivumaara()
    {
        return sivumaara;
    }
 
    
    /**
     * Muokataan kirja-olion nimeä
     * @param uusiNimi uusi Nimi
     */
    public void setTeos(String uusiNimi)
    {
        teos = uusiNimi;
        
    }
    
    /**
     * Muokataan kirja-olion hintaa
     * @param uusiHinta uusi hinta
     */
    public void setHinta(String uusiHinta)
    {
        StringBuilder hintateksti =new StringBuilder(uusiHinta);
        for(int i = 0; i<uusiHinta.length(); i++)
        {
            if(uusiHinta.charAt(i) == ',')
            {
                hintateksti.setCharAt(i, '.');
            }
        }
        double uusiHintaInt = Double.parseDouble(hintateksti.toString()); 
        if(uusiHintaInt > 0)
        {
            hinta = uusiHintaInt;  
        }   
    }
    
    /**
     * Muokataan kirja-olion kirjailijaa
     * @param uusiKirjailija uusi kirjialija.
     */
    public void setKirjailija(String uusiKirjailija)
    {
        kirjailija = uusiKirjailija;       
    }
    
    /**
     * Muokataan kirja-olion sivumäärää
     * @param uusiSivumaara uusi sivumäärä.
     */
    public void setSivumaara(String uusiSivumaara)
    {
        try
        {
        sivumaara = Integer.parseInt(uusiSivumaara);       
        }
        catch(Exception e)
        {
            System.out.println("Sivumäärän oltava kokonaisluku");
        }
    }
    
    /**
     * Pääohjelma
     * @param args ei käytössä
     */
    public static void main(String args[])
    {
        Kirja Kurjat = new Kirja();
        Kurjat.setHinta("13,50");
        Kurjat.setSivumaara(null);
        Kurjat.setTeos("Kurjat");
        Kurjat.setKirjailija("Victor Hugo");
        Kurjat.setSivumaara("1050");
        System.out.println("Kirjan nimi on " + Kurjat.getTeos());
        System.out.println("Kirjailija on " + Kurjat.getKirjailija());
        System.out.println("Kirjassa on " + Kurjat.getSivumaara() + " Sivua");
        System.out.println("Kirjan hinta on " + Kurjat.getHinta()+ "€.");   
        Kurjat.setHinta("9.25");
        System.out.println("Kirjan alennettu hinta on " + Kurjat.getHinta()+ "€."); 
        
    }
    
}
